import { TextSelection, EditorState, Transaction } from "prosemirror-state";
import { EditorView as PMEditorView } from "prosemirror-view";
import { Node } from "prosemirror-model";
import { EditorView } from "@codemirror/view";
import { Compartment } from "@codemirror/state";
import { CodeBlockSettings } from "./types";
export declare function computeChange(oldVal: string, newVal: string): {
    from: number;
    to: number;
    text: string;
} | null;
export declare const asProseMirrorSelection: (pmDoc: Node, cmView: EditorView, getPos: (() => number) | boolean) => TextSelection<any>;
export declare const forwardSelection: (cmView: EditorView, pmView: PMEditorView, getPos: (() => number) | boolean) => void;
export declare const valueChanged: (textUpdate: string, node: Node, getPos: (() => number) | boolean, view: PMEditorView) => void;
export declare const maybeEscape: (unit: "char" | "line", dir: -1 | 1, cm: EditorView, view: PMEditorView, getPos: boolean | (() => number)) => boolean;
export declare const backspaceHandler: (pmView: PMEditorView, view: EditorView) => boolean;
export declare const setMode: (lang: string, cmView: EditorView, settings: CodeBlockSettings, languageConf: Compartment) => Promise<void>;
export declare const codeBlockArrowHandlers: {
    ArrowLeft: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: PMEditorView<any> | undefined) => boolean;
    ArrowRight: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: PMEditorView<any> | undefined) => boolean;
    ArrowUp: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: PMEditorView<any> | undefined) => boolean;
    ArrowDown: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: PMEditorView<any> | undefined) => boolean;
};
